/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.GrupoRuta;
import com.rjconsultores.ventaboletos.service.GrupoRutaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.util.resource.Labels;
import org.zkoss.zul.Button;
/**
 * 
 * @author Administrador
 */
@Controller("editarGrupoRutaController")
@Scope("prototype")
public class EditarGrupoRutaController extends MyGenericForwardComposer {

	@Autowired
	private GrupoRutaService grupoRutaService;
	private GrupoRuta grupoRuta;
	private MyListbox grupoRutaList;
	private MyTextbox txtNome;
	private Button btnApagar;
	private static Logger log = Logger.getLogger(EditarGrupoRutaController.class);

	public GrupoRuta getGrupoRuta() {
		return grupoRuta;
	}

	public void setGrupoRuta(GrupoRuta grupoRuta) {
		this.grupoRuta = grupoRuta;
	}

	public MyTextbox getTxtNome() {
		return txtNome;
	}

	public void setTxtNome(MyTextbox txtNome) {
		this.txtNome = txtNome;
	}

	public Button getBtnApagar() {
		return btnApagar;
	}

	public void setBtnApagar(Button btnApagar) {
		this.btnApagar = btnApagar;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		grupoRuta = (GrupoRuta) Executions.getCurrent().getArg().get("grupoRuta");
		grupoRutaList = (MyListbox) Executions.getCurrent().getArg().get("grupoRutaList");

		if (grupoRuta.getGrupoRutaId() == null) {
			btnApagar.setVisible(Boolean.FALSE);
		}

		txtNome.focus();
	}

	public void onClick$btnSalvar(Event ev) throws InterruptedException {
		txtNome.getText();

		try {
			String nomeGrupoRuta = grupoRuta.getDescGrupo();
			List<GrupoRuta> lsGrupoRuta = grupoRutaService.buscarPorNome(nomeGrupoRuta);

			if (lsGrupoRuta.isEmpty()) {
				grupoRuta.setActivo(Boolean.TRUE);
				grupoRuta.setFecmodif(Calendar.getInstance().getTime());
				grupoRuta.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

				if (grupoRuta.getGrupoRutaId() == null) {
					grupoRutaService.suscribir(grupoRuta);
					grupoRutaList.addItem(grupoRuta);
				} else {
					grupoRutaService.actualizacion(grupoRuta);
					grupoRutaList.updateItem(grupoRuta);
				}

				Messagebox.show(
						Labels.getLabel("editarGrupoRutaController.MSG.suscribirOK"),
						Labels.getLabel("editarGrupoRutaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				closeWindow();
			} else {
				Messagebox.show(
						Labels.getLabel("MSG.Registro.Existe"),
						Labels.getLabel("editarGrupoRutaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			}
		} catch (Exception ex) {
			log.error("editarGrupoRutaController: " + ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarGrupoRutaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagar(Event ev) {
		try {
			int resp = Messagebox.show(
					Labels.getLabel("editarGrupoRutaController.MSG.borrarPergunta"),
					Labels.getLabel("editarGrupoRutaController.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {
				grupoRutaService.borrar(grupoRuta);

				Messagebox.show(
						Labels.getLabel("editarGrupoRutaController.MSG.borrarOK"),
						Labels.getLabel("editarGrupoRutaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				grupoRutaList.removeItem(grupoRuta);

				closeWindow();
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}
}
